<template>
  <div>
    <div v-if="loading">Loading...</div>
    <template v-else>
      <form>
        <div class="form-row">
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Search title</label>
            <input
              class="form-control"
              placeholder="Search title"
              v-model="titleSearch"
            />
          </div>
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Search description</label>
            <input
              class="form-control"
              placeholder="Search description"
              v-model="descriptionSearch"
            />
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-md-3">
            <label>After</label><br />
            <input
              type="date"
              v-model="after"
              :min="minDate"
              :max="maxDate"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Before</label><br />
            <input
              type="date"
              v-model="before"
              :min="minDate"
              :max="maxDate"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Type</label>
            <multiselect
              v-model="selectedTypes"
              :options="allTypes"
              :multiple="true"
              placeholder="Select one or multiple types"
            />
          </div>
        </div>
      </form>
      <paginated-table
        :items="filteredEvents"
        :total-items="event_data.length"
        :per-page-default="500"
      >
        <template v-slot:header>
          <tr>
            <th style="width: 25%;">Title</th>
            <th>Description</th>
            <th style="width: 10%;">Date</th>
          </tr>
        </template>
        <template v-slot:row="{ item: event }">
          <td v-if="event.title">
          <span v-if="event.type === 'Commit'">
            <img style="height: 1.2em;" src="assets/commit.png" alt="Commit" />
          </span>
          <span v-else-if="event.type === 'Note'">
            <img style="height: 1.2em;" src="assets/comment.png" alt="Comment" />
          </span>
          <span v-else-if="event.type === 'DiscussionNote'">
            <img style="height: 1.2em;" src="assets/comment-thread.png" alt="Comment in thread" />
          </span>
          <span v-else-if="event.type === 'DiffNote'">
            <img style="height: 1.2em;" src="assets/diff-note.png" alt="Comment on diff" />
          </span>
          <span v-else-if="event.type === 'Issue'">
            <img style="height: 1.2em;" src="assets/issue.png" alt="Issue" />
          </span>
          <span v-else-if="event.type === 'MergeRequest'">
            <img style="height: 1.2em;" src="assets/merge-request.png" alt="Merge Request" />
          </span>
          <span v-else>
            [{{ event.type }}]
          </span>
          <a :href=event.web_url>{{ event.title }}</a></td>
          <td v-else>[{{ event.type }}] <a :href=event.web_url>Link</a></td>
          <td><span v-html="event.description"></span></td>
          <td>{{ event.date }}</td>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";
import PaginatedTable from "./components/paginated-table.vue";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

export default {
  components: {
    Multiselect,
    PaginatedTable
  },
  data() {
    return {
      event_data: [],
      titleSearch: "",
      selectedTypes: [],
      descriptionSearch: "",
      after: null,
      before: null,
      loading: true,
    };
  },
  async mounted() {
    const event_response = await fetch("./events.json");
    this.event_data = await event_response.json();
    this.loading = false;
    this.before = this.dates.slice(-1)[0];
    this.after = this.dates[0];
  },
  methods: {
    regexSearch(event, field, regex) {
      var searchString = ""
      if(field == "title" && event.title != null) {
        searchString += event.title
      }
      if(field == "description") {
        searchString += " " + event.description
      }
      return searchString.toLocaleLowerCase().match(regex)
    },
    searchLower(field) {
      return field.toLocaleLowerCase();
    }
  },
  computed: {
    filteredEvents() {
      return this.event_data
        .filter((event) => {
          let visible = true;
          if (visible && this.titleSearch) {
            const regex = new RegExp(this.searchLower(this.titleSearch), "gi");
            visible = visible && this.regexSearch(event, "title", regex);
          }
          if (visible && this.descriptionSearch) {
            const regex = new RegExp(this.searchLower(this.descriptionSearch), "gi");
            visible = visible && this.regexSearch(event, "description", regex);
          }
          if (visible && this.selectedTypes.length) {
            visible =
              visible && this.selectedTypes.includes(event.type || null);
          }

          visible =
            visible &&
            event.date <= this.before &&
            this.after <= event.date;
          return visible;
        })
        .sort((a, b) => {
          const valA = a["date"];
          const valB = b["date"];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1);
        });
    },
    dates() {
      return this.event_data.flatMap((x) => (x.date ? x.date : [])).sort();
    },
    allTypes() {
      return uniqAndSort(this.event_data.map((event) => event.type).flat());
    },
    maxDate() {
      console.log(this.dates.slice(-1)[0])
      return this.dates.slice(-1)[0];
    },
    minDate() {
      console.log(this.dates[0])
      return this.dates[0];
    }
  },
};
</script>